/* ===================================================================
 * MIXINS SPECIFIQUES AU GABARIT
 * =================================================================*/

/*
 *   Simplification de la déclaration d'une image de fond
 *   => @a : nom du fichier image
 *   => @b : couleur de fond, repétition...
 *   Exemple :
 *       .backgroundImage('puce.png', no-repeat 0 0 #fff);
 */
.background(@a, @b...) {
    background: url('@{cssDir}images/@{a}') @b;
}

.backgroundImage(@a) {
    background-image: url('@{cssDir}images/@{a}');
}

.contentImage(@a) {
    content: url('@{cssDir}images/@{a}');
}

/*
 *   Simplification de la déclaration d'une police spécifique
 *   => @family: nom de la police déclarée ensuite avec font-family
 *   => @police: nom des fichiers ttf, eot etc...
 *   => @font-weight: graisse de la police (normal, 600...)
 *   => @font-style: style de la police (normal, italic...)
 *   Exemple :
 *       @font-face { .font-face('ExempleFont', 'ExempleFont-webfont'); }
 */
.font-face(
    @family,
    @police,
    @font-weight: normal,
    @font-style: normal
) {
    font-family: '@{family}';
    src: url('@{cssDir}police/@{police}.woff2') format('woff2'),
    url('@{cssDir}police/@{police}.woff') format('woff');
    font-weight: @font-weight;
    font-style: @font-style;
}

/*
 *   Effets graphiques simples :
 */
.linearGradient(@color1, @color2) {
    background: -webkit-linear-gradient(top, @color1 0, @color2 100%);
    background: -ms-linear-gradient(top, @color1 0, @color2 100%); /* IE10+ */
    filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='@color1', endColorstr='@color2', GradientType=0);
    background: linear-gradient(to bottom, @color1 0, @color2 100%);
    /* Attention pour IE9 il faut désactiver le filter en mettant un filter: none; sous peine de cumuler les deux dégradés (linear-gradient + filter microsoft) */
}

/*
 *  Formulaires :
 */

/*
 *   Checkbox :
 *   => @checkboxSize:              largeur et hauteur de la case
 *   => @checkboxBgColor:           couleur de fond de la case
 *   => @checkboxBgColorHover:      couleur de fond de la case au survol
 *   => @checkboxBgCheckedColor:    couleur de fond de la case cochée
 *   => @checkboxLeft:              position absolue left de la case
 *   => @checkboxTop:               position absolue top de la case
 *   => @coche:                     motif à afficher pour la coche, code hexa ou image, ex: .checkbox(url('@{cssDir}images/barreHaut_puce.gif'))
 *   => @cocheFontsize:             taille de la coche
 *   => @cocheLeft:                 position absolue left de la coche
 *   => @cocheTop:                  position absolue top de la coche
 *   => @cocheColor:                couleur de la coche
 *   => @contourSize:               largeur du contour
 *   => @contourColor:              couleur du contour
 *   => @contourRadius:             arrondi du contour
 *   => @contourHoverColor:         couleur du contour au survol
 */
.checkBox(
    @checkboxSize: 16px,
    @checkboxBgColor: #ffffff,
    @checkboxBgColorHover: mix(#ffffff, @checkboxBgColor, 35%),
    @checkboxBgCheckedColor: #ffffff,
    @checkboxLeft: 0,
    @checkboxTop: 4px,
    @coche: '✔',
    @cocheFontsize: 12px,
    @cocheLeft: 3px,
    @cocheTop: 0,
    @cocheColor: #09ad7e,
    @contourColor: #000000,
    @contourSize: 1px,
    @contourRadius: 3px,
    @contourHoverColor: mix(#ffffff, @contourColor, 35%)
) {
    /* Cachons la case à cocher */
    [type='checkbox']:not(:checked),
    [type='checkbox']:checked {
        position: absolute;
        opacity: 0;
    }
    /* on prépare le label */
    [type='checkbox']:not(:checked) + label,
    [type='checkbox']:checked + label {
        position: relative; /* permet de positionner les pseudo-éléments */
        padding: 0 1.5rem 0 3rem; /* fait un peu d'espace pour notre case à venir */
        cursor: pointer; /* affiche un curseur adapté */
    }
    /* Aspect des checkboxes */
    /* :before sert à créer la case à cocher */
    [type='checkbox']:not(:checked) + label:before,
    [type='checkbox']:checked + label:before {
        content: '';
        left: @checkboxLeft;
        top: @checkboxTop;
        position: absolute;
        width: @checkboxSize;
        height: @checkboxSize; /* dim. de la case */
        border: @contourSize solid @contourColor;
        background-color: @checkboxBgColor;
        border-radius: @contourRadius; /* angles arrondis */
        box-sizing: border-box;
    }
    /* Aspect général de la coche */
    [type='checkbox']:not(:checked) + label:after,
    [type='checkbox']:checked + label:after {
        position: absolute;
        content: @coche;
        left: @cocheLeft;
        top: @cocheTop;
        font-size: @cocheFontsize;
        color: @cocheColor;
        transition: all .2s; /* on prévoit une animation */
    }
    /* Aspect si pas cochée */
    [type='checkbox']:not(:checked) + label:after {
        transform: scale(0); /* mise à l'échelle à 0 */
        opacity: 0; /* coche invisible */
    }
    /* Aspect si cochée */
    [type='checkbox']:checked + label:before {
        background-color: @checkboxBgCheckedColor;
    }
    [type='checkbox']:checked + label:after {
        transform: scale(1); /* mise à l'échelle 1:1 */
        opacity: 1; /* coche opaque */
    }

    /* aspect désactivée */
    [type='checkbox']:disabled:not(:checked) + label:before,
    [type='checkbox']:disabled:checked + label:before {
        box-shadow: none;
        border-color: #bbb;
        background-color: #ddd;
    }
    /* styles de la coche (si cochée/désactivée) */
    [type='checkbox']:disabled:checked + label:after {
        color: #999;
    }
    /* on style aussi le label quand désactivé */
    [type='checkbox']:disabled + label {
        color: #aaa;
    }

    /* aspect au hover de l'élément */
    [type='checkbox']:checked:not(:disabled):hover + label:before {
        border-color: @contourColor;
        background-color: @checkboxBgCheckedColor;
    }
    [type='checkbox']:not(:checked):not(:disabled):hover + label:before {
        border-color: @contourHoverColor;
        background-color: @checkboxBgColorHover;
    }
    [type='checkbox']:not(:disabled):focus + label:before {
        outline: 1px dotted black;
    }
}

/*
 *   Radio bouton :
 *   => @radioSize:             largeur et hauteur du bouton radio
 *   => @radioBgColor:          couleur de fond du bouton radio
 *   => @radioBgColorHover:     couleur de fond du bouton radio au survol
 *   => @radioBgCheckedColor:   couleur de fond du bouton radio coché
 *   => @radioLeft:             position absolue left de la case
 *   => @radioTop:              position absolue top de la case
 *   => @cocheLeft:             position absolue left de la coche
 *   => @cocheTop:              position absolue top de la coche
 *   => @cocheSize:             largeur et hauteur de la coche
 *   => @cocheColor:            couleur de la coche
 *   => @contourColor:          couleur du contour
 *   => @contourSize:           largeur du contour
 *   => @contourHoverColor:     couleur du contour au survol
 */
.radioBouton(
    @radioSize: 16px,
    @radioBgColor: #ffffff,
    @radioBgColorHover: mix(#ffffff, @radioBgColor, 35%),
    @radioBgCheckedColor: #ffffff,
    @radioLeft: 0,
    @radioTop: 4px,
    @cocheLeft: 4px,
    @cocheTop: 8px,
    @cocheSize: 8px,
    @cocheColor: #000000,
    @contourColor: #000000,
    @contourSize: 1px,
    @contourHoverColor: mix(#ffffff, @contourColor, 35%)
) {
    /* Cachons le bouton radio */
    [type='radio']:not(:checked),
    [type='radio']:checked {
        position: absolute;
        opacity: 0;
    }
    /* on prépare le label */
    [type='radio']:not(:checked) + label,
    [type='radio']:checked + label {
        position: relative; /* permet de positionner les pseudo-éléments */
        padding: 0 1.5rem 0 3rem; /* fait un peu d'espace pour notre bouton à venir */
        cursor: pointer; /* affiche un curseur adapté */
        vertical-align: middle;
    }
    /* Aspect des boutons radios */
    /* :before sert à créer le bouton radio */
    [type='radio']:not(:checked) + label:before,
    [type='radio']:checked + label:before {
        content: '';
        position: absolute;
        top: @radioTop;
        left: @radioLeft;
        width: @radioSize;
        height: @radioSize; /* dim. du bouton */
        border: @contourSize solid @contourColor;
        background-color: @radioBgColor;
        border-radius: 100%; /* angles arrondis */
        box-sizing: border-box;
    }
    /* Aspect général de la coche */
    [type='radio']:not(:checked) + label:after,
    [type='radio']:checked + label:after {
        position: absolute;
        content: '';
        width: @cocheSize;
        height: @cocheSize;
        border-radius: 100%;
        top: @cocheTop;
        left: @cocheLeft;
        background-color: @cocheColor;
        transition: all .2s; /* on prévoit une animation */
    }
    /* Aspect si pas cochée */
    [type='radio']:not(:checked) + label:after {
        transform: scale(0); /* mise à l'échelle à 0 */
        opacity: 0; /* coche invisible */
    }
    /* Aspect si cochée */
    [type='radio']:checked + label:before {
        background-color: @radioBgCheckedColor;
    }
    [type='radio']:checked + label:after {
        transform: scale(1); /* mise à l'échelle 1:1 */
        opacity: 1; /* coche opaque */
    }

    /* aspect désactivée */
    [type='radio']:disabled:not(:checked) + label:before,
    [type='radio']:disabled:checked + label:before {
        box-shadow: none;
        border-color: #bbb;
        background-color: #ddd;
    }
    [type='radio']:disabled:not(:checked) + label:after,
    [type='radio']:disabled:checked + label:after {
        background-color: #999;
    }
    /* styles de la coche (si cochée/désactivée) */
    [type='radio']:disabled:checked + label:after {
        color: #999;
    }
    /* on style aussi le label quand désactivé */
    [type='radio']:disabled + label {
        color: #aaa;
    }

    /* aspect au hover de l'élément */
    [type='radio']:checked:not(:disabled):hover + label:before {
        border-color: @contourColor;
        background-color: @radioBgCheckedColor;
    }
    [type='radio']:not(:checked):not(:disabled):hover + label:before {
        border-color: @contourHoverColor;
        background-color: @radioBgColorHover;
    }
    [type='radio']:not(:disabled):focus + label:before {
        outline: 1px dotted black;
    }
}

/*
 *   Custom select :
 *   => @arrow:   nom du fichier image
 *   => @taille:  width du background en pixels permettant de calculer le padding-right
 *   => @right:   espacement de l'image par rapport au bord droit
 */
.selectBox(@arrow: 'select_arrow.png', @taille: 25px, @right: 5px) {
    @taille2: (( 5px + @taille + @right)); /* calcul l'espace nécessaire entre l'image et le texte dans le select  */
    select {
        .backgroundImage(@arrow);
        text-overflow: ellipsis;
        -moz-appearance: none; /* Firefox */
        -webkit-appearance: none; /* Safari and Chrome */
        appearance: none;
        background-repeat: no-repeat;
        background-position: 100% 50%;
        background-position: ~'calc(100% - @{right})' center;
        padding-right: @taille2;
        &[size] {
            background-image: none;
            padding-right: 0;
            height: auto;
            vertical-align: top;
        }
        &::-ms-expand {
            display: none;
        }
    }
}

/*
 *   Alignement : Permet d'aligner en pourcentage un élément via absolute et tranform
 *   !! Attention !! Il faut que le bloc container soit en position relative ou absolute.
 *   => @x:  alignement sur l'axe x
 *   => @y:  alignement sur l'axe y
 */
.alignementX(@x: 50%) {
    transform: translateX(-50%);
    left: @x;
    position: absolute;
}

.alignementY(@y: 50%) {
    transform: translateY(-50%);
    top: @y;
    position: absolute;
}

.alignement(@x: 50%, @y: 50%) {
    transform: translate(-50%, -50%);
    top: @y;
    left: @x;
    position: absolute;
}

/*
 *   Colonnage grille
 *   => @nbCol:    nombre de colonne de la grille
 *   => @nbMargin:     nombre de gouttières de la grille
 */
.gridWidth(@nbCol, @nbMargin) {
    width: percentage((@nbCol * @gridCol + @nbMargin * @gridMargin) / @desktop);
}

/*
 *   Liens d'évitement accessibilité
 *   => @color:         couleur des liens + couleur de la bordure basse du bloc
 *   => @colorHover:    couleur des liens au survol
 *   => @bgColor:       couleur de fond des liens
 *   => @bgColorHover:  couleur de fond des liens au survol
 *   => @bgGlobal:      couleur de fond du bloc
 */
.lienEvitement(
    @color: @texte,
    @colorHover: #fff,
    @bgColor: #fff,
    @bgColorHover: @texte,
    @bgGlobal: #fff
) {
    position: fixed;
    z-index: -1;
    top: -20px;
    width: 100%;
    transition: all 0.3s;
    background-color: @bgGlobal;
    border-bottom: 3px solid @color;
    opacity: 0;
    &.focus {
        top: 0;
        z-index: 100;
        opacity: 1;
    }
    ul {
        list-style: none;
        li {
            display: inline-block;
            margin-right: 1em;
        }
        a {
            display: block;
            padding: 0.5em 1em;
            color: @color;
            background-color: @bgColor;
            text-decoration: none;
            &:hover,
            &:focus {
                color: @colorHover;
                text-decoration: none;
                background-color: @bgColorHover;
            }
        }
    }
}

/*
 *   Bouton standard (validation des formulaires)
 *   => @fontSize:          taille du libellé
 *   => @lineHeight:        line-height du libellé
 *   => @color:             couleur du libellé
 *   => @bgColor:           couleur de fond du bouton
 *   => @borderColor:       couleur du contour
 *   => @borderSize:        largeur du contour
 *   => @colorHover:        couleur du libellé au survol
 *   => @bgColorHover:      couleur de fond du bouton au survol
 *   => @borderColorHover:  couleur du contour au survol
 *   => @radius:            arrondi des angles
 *   => @paddingH:          padding haut/bas
 *   => @paddingV:          padding gauche/droite
 */
.btnStandard(
    @fontSize: 1.6,
    @lineHeight: 2.4,
    @color: #fff,
    @bgColor: @texte,
    @borderColor: @texte,
    @borderSize: 1px,
    @colorHover: #fff,
    @bgColorHover: mix(#ffffff, @bgColor, 25%),
    @borderColorHover: mix(#ffffff, @borderColor, 25%),
    @radius: 0,
    @paddingV: 1rem,
    @paddingH: 5%
) {
    font-size: @fontSize+rem;
    line-height: @lineHeight+rem;
    color: @color !important;
    background-color: @bgColor;
    border: @borderSize solid @borderColor;
    padding: @paddingV @paddingH;
    border-radius: @radius;
    display: inline-block;
    vertical-align: middle;
    text-transform: uppercase;
    text-decoration: none !important;
    transition: all 0.2s;
    &:hover,
    &:active,
    &:focus {
        text-decoration: none;
        background-color: @bgColorHover;
        color: @colorHover !important;
        border-color: @borderColorHover;
    }
}

/*
 *   Bouton haut de page
 *   => @pictoFA:           picto Font Awesome Solid
 *   => @fontSize:          taille du picto FA
 *   => @width:             largeur du bouton
 *   => @height:            hauteur du bouton
 *   => @color:             couleur du picto FA
 *   => @bgColor:           couleur de fond du bouton
 *   => @borderColor:       couleur du contour du bouton
 *   => @borderSize:        largeur du contour du bouton
 *   => @radius:            arrondi des angles
 *   => @right:             position droite
 *   => @bottom:            position bas
 *   => @colorHover:        couleur du picto FA au survol
 *   => @bgColorHover:      couleur de fond du bouton au survol
 *   => @borderColorHover:  couleur du contour du bouton au survol
 *   => @shadow:            shadow du bouton
 */
.btnHautDePage(
    @pictoFA: '\f062',
    @fontSize: 1.6,
    @width: 40px,
    @height: 40px,
    @color: #fff,
    @bgColor: @texte,
    @borderColor: @texte,
    @borderSize: 1px,
    @radius: 100%,
    @right: 20px,
    @bottom: 20px,
    @colorHover: #fff,
    @bgColorHover: red,
    @borderColorHover:
    @bgColorHover,
    @shadow: 1px 1px 16px 0 rgba(0, 0, 0, 0.3)
) {
    font-size: @fontSize+rem;
    width: @width;
    height: @height;
    color: @color;
    background-color: @bgColor;
    border: @borderSize solid @borderColor;
    border-radius: @radius;
    right: @right;
    bottom: @bottom;
    position: fixed;
    z-index: 1000;
    text-align: center;
    box-shadow: @shadow;
    transition-duration: 0.3s;
    transition-timing-function: ease;
    transition-property: box-shadow, background-color, color, border-color;
    &:hover {
        color: @colorHover;
        background-color: @bgColorHover;
        border-color: @borderColorHover;
    }
    &::before {
        .fas;
        content: @pictoFA;
        .alignement;
    }
    @media screen and (max-width: @mobile) {
        .fontSize(@fontSize / 1.5);
        width: @width / 1.5;
        height: @height / 1.5;
        right: @right / 2;
        bottom: @bottom / 2;
    }
}
